include doszip.inc
include io.inc
include string.inc
include errno.inc
include conio.inc
include progress.inc
ifdef __DLL__
 include dll.inc
endif

_COPY_IARCHIVE  equ 02h ; source is archive
_COPY_OARCHIVE  equ 04h ; target is archive
_COPY_IEXTFILE  equ 08h ; source is .DLL archive - %dz%/doc/plugins/.dll
_COPY_OEXTFILE  equ 40h ; target is .DLL archive

init_copy	proto :dword, :dword
fp_copydirectory proto :dword
fp_copyfile	proto :dword, :dword
copyfile	proto :qword, :dword, :dword
externdef	copy_jump:dword
externdef	copy_flag:byte
externdef	cp_move:byte

_COPY_TOZIP	equ 0004h
_COPY_TOARCHIVE equ _COPY_TOZIP

.code

move_initfiles proc private filename:dword
	invoke strfcat,addr __outfile,addr __outpath,filename
	invoke strfcat,addr __srcfile,addr __srcpath,filename
	ret
move_initfiles endp

move_deletefile proc private result:dword, flag:dword
	mov eax,result
	add eax,copy_jump
	.if eax
	    mov eax,result
	    .if !eax
		mov copy_jump,eax
		inc jmp_count
	    .endif
	.else
	    .if byte ptr flag & _A_RDONLY
		invoke setfattr,addr __srcfile,0
	    .endif
	    invoke remove,addr __srcfile
	    mov eax,result
	.endif
	ret
move_deletefile endp

fp_movedirectory proc private directory:dword
	.if !progress_set(0,directory,0)
	    invoke setfattr,directory,eax
	    .if rmdir(directory)
		sub eax,eax
		.if jmp_count == eax
		    invoke erdelete,directory
		.endif
	    .endif
	.endif
	ret
fp_movedirectory endp

fp_movefile proc private directory:dword, wfblk:dword
	invoke fp_copyfile,directory,wfblk
	mov edx,wfblk
	invoke move_deletefile,eax,[edx].S_WFBLK.wf_attrib
	ret
fp_movefile endp

fblk_movefile proc private uses ebx fblk:dword
	mov ebx,fblk
	.if !progress_set(addr [ebx].S_FBLK.fb_name,
		addr __outpath,[ebx].S_FBLK.fb_size)
	    .if rename(addr __srcfile,addr __outfile)
		invoke copyfile,[ebx].S_FBLK.fb_size,[ebx].S_FBLK.fb_time,[ebx].S_FBLK.fb_flag
		invoke move_deletefile,eax,[ebx].S_FBLK.fb_flag
	    .endif
	.endif
	ret
fblk_movefile endp

fblk_movedirectory proc private uses esi edi fblk:dword
local path[WMAXPATH]:byte, fname:dword
	mov eax,fblk
	add eax,S_FBLK.fb_name
	mov fname,eax
	.if !progress_set(eax,addr __outpath,0)
	    invoke move_initfiles,fname
	    .if rename(eax,addr __outfile)
		lea edi,path
		invoke strfcat,addr path,addr __srcpath,fname
		mov fp_directory,fp_copydirectory
		.if scansub(addr path,addr cp_stdmask,1)
		    mov eax,-1
		.else
		    .if copy_jump == eax
			mov fp_directory,fp_movedirectory
			invoke scansub,addr path,addr cp_stdmask,0
		    .else
			mov copy_jump,eax
			inc jmp_count
		    .endif
		.endif
	    .endif
	.endif
	ret
fblk_movedirectory endp

cmmove proc uses edi
	.if cpanel_findfirst()
	    mov edi,edx
	    .if ecx & (_FB_ARCHZIP or _FB_UPDIR)
		jmp @F
	    .endif
	    .if init_copy(edi,0)
ifdef __DLL__
		.if copy_flag & _COPY_OEXTFILE
		    mov eax,panela
		    .if eax == cpanel
			mov eax,panelb
		    .endif
		    mov edx,[eax].S_PANEL.pn_wsub
		    mov eax,cpanel
		    mov eax,[eax].S_PANEL.pn_wsub
		    invoke dll_call,_DLL_MOVE,edx,eax,edi,0
		.elseif !(copy_flag & _COPY_IARCHIVE or _COPY_OARCHIVE)
else
		.if !(copy_flag & _COPY_IARCHIVE or _COPY_OARCHIVE)
endif
		    mov jmp_count,0
		    mov fp_fileblock,fp_movefile
		    invoke progress_open,addr cp_move,addr cp_move
		    mov eax,[edi]
		    .if eax & _FB_SELECTED
			.repeat
			    .if eax & _A_SUBDIR
				invoke fblk_movedirectory,edi
			    .else
				mov eax,edi
				add eax,S_FBLK.fb_name
				invoke move_initfiles,eax
				invoke fblk_movefile,edi
			    .endif
			    .break .if eax
			    mov eax,not _FB_SELECTED
			    and [edi],eax
			    mov eax,cpanel
			    .break .if !panel_findnext()
			    mov edi,edx
			    mov eax,ecx
			.until 0
		    .else
			.if eax & _A_SUBDIR
			    invoke fblk_movedirectory,edi
			.else
			    invoke fblk_movefile,edi
			.endif
		    .endif
		.else
		    jmp @F
		.endif
		invoke progress_close
		mov eax,1
	    .endif
	.endif
      @@:
	ret
cmmove  endp

.data

jmp_count dd 0

	END
