include _tinfo.inc
include string.inc
include alloc.inc
include errno.inc

.code

;-----------------------------------------------------------------------------
; Open
;-----------------------------------------------------------------------------

tiopen proc uses esi ebx
	.if malloc(SIZE S_TINFO)
	    invoke memzero,eax,SIZE S_TINFO
	    mov esi,eax
	    mov old_bcrc,0
	    mov eax,titabsize
	    mov [esi].S_TINFO.ti_tabz,eax
	    mov ah,at_background[B_Panel]
	    or  ah,7;at_foreground[F_Desktop]
	    mov al,' '
	    mov [esi].S_TINFO.ti_clat,eax
	    mov [esi].S_TINFO.ti_stat,eax
	    inc [esi].S_TINFO.ti_cursor.bVisible
	    mov [esi].S_TINFO.ti_cursor.dwSize,CURSOR_NORMAL
	    mov eax,_scrcol	; adapt to current screen
	    mov [esi].S_TINFO.ti_cols,eax
	    mov eax,_scrrow
	    inc eax
	    mov [esi].S_TINFO.ti_rows,eax
	    mov ecx,telsize
	    mov eax,128
	    shl eax,cl
	    mov [esi].S_TINFO.ti_bcol,eax
	    mov eax,esi
	    .if tialloc()
		.if tigetfile()
		    mov ebx,edx
		    mov [esi].S_TINFO.ti_prev,ebx	; Link to last file
		    mov [ebx].S_TINFO.ti_next,esi
		.endif
		mov eax,teflag
		or  [esi].S_TINFO.ti_flag,eax
		.if [esi].S_TINFO.ti_flag & _T_USEMENUS
		    inc [esi].S_TINFO.ti_ypos
		    inc [esi].S_TINFO.ti_cursor.y
		    dec [esi].S_TINFO.ti_rows
		.endif
		mov  eax,esi
		test eax,eax
		jmp  @F
	    .endif
	    invoke free,esi
	    jmp tiopen_nomem
	.else
	    jmp tiopen_nomem
	.endif
      @@:
	ret
    tiopen_nomem:
	invoke ermsg,0,addr CP_ENOMEM
	xor eax,eax
	jmp @B
tiopen endp

ticlose proc uses esi edi ebx
	mov esi,eax
	sub edi,edi
	.if [esi].S_TINFO.ti_flag & _T_MALLOC or _T_GLALLOC
	    invoke tifree
	    invoke dlclose,addr [esi].S_TINFO.ti_DOBJ
	.endif
	.if tigetfile()
	    mov edi,[esi].S_TINFO.ti_prev
	    mov ebx,[esi].S_TINFO.ti_next
	    mov [esi].S_TINFO.ti_prev,0
	    mov [esi].S_TINFO.ti_next,0
	    .if ebx && [ebx].S_TINFO.ti_prev == esi
		mov [ebx].S_TINFO.ti_prev,edi
	    .endif
	    .if edi && [edi].S_TINFO.ti_next == esi
		mov [edi].S_TINFO.ti_next,ebx
	    .else
		mov edi,ebx
	    .endif
	.endif
	mov tinfo,edi
	invoke free,esi
	sub eax,eax
	ret
ticlose endp

	END
